#!/bin/bash

rm -rf build-mingw
mkdir build-mingw && cd build-mingw && cmake -G "MSYS Makefiles" -DCMAKE_C_FLAGS="-DLOCALEDIR" .. && make
[ 0 != $? ] && echo "make failed ;-(" && exit 1

mkdir -p src/locale/ru/LC_MESSAGES
mkdir -p src/locale/it/LC_MESSAGES
cp po/ru/gettextex2.gmo src/locale/ru/LC_MESSAGES/gettextex2.mo
cp po/it/gettextex2.gmo src/locale/it/LC_MESSAGES/gettextex2.mo

mkdir -p run/locale/ru/LC_MESSAGES
mkdir -p run/locale/it/LC_MESSAGES
cp po/ru/gettextex2.gmo run/locale/ru/LC_MESSAGES/gettextex2.mo
cp po/it/gettextex2.gmo run/locale/it/LC_MESSAGES/gettextex2.mo

cd run
./gettextex2_test
